; This file is a part of `marmalade' ver 1.01c, a supporting system for
; playing and inputting MML data on UNIX.
;
; To use this file, add the following 2 lines to .emacs ...
;(setq auto-mode-alist (append auto-mode-alist '(("\\.mml$" . mml-mode))))
;(autoload 'mml-mode "mml-mode" "MML mode." t)
;						    nide@ics.nara-wu.ac.jp

(defun mml-mode ()
  "Major mode for editing MML code."
  (interactive)
  (setq mode-name "MML")
  (setq major-mode 'mml-mode)
  (use-local-map mml-mode-map)
  (make-local-variable 'mml-compile-output-buffer)
  (setq mml-compile-output-buffer
	(generate-new-buffer "*MML compile output*"))
  (run-hooks 'mml-mode-hook))
(defun playmml-buffer ()
  "Play MML buffer in background."
  (interactive)
  (let ((curbuf (current-buffer)) (curwin (selected-window)))
    (set-buffer mml-compile-output-buffer)
    (erase-buffer)
    (set-buffer curbuf)
    (if (not (zerop (call-process-region (point-min) (point-max) "playmml" 
					 nil mml-compile-output-buffer nil
					 "-br" "-")))
	(progn
	  (switch-to-buffer-other-window mml-compile-output-buffer)
	  (select-window curwin))
      )))
(defun playmml-file ()
  "Play MML file in background."
  (interactive)
  (let ((curbuf (current-buffer)) (fnm buffer-file-name)
	(curwin (selected-window)))
    (if fnm
	(progn
	  (if (and (buffer-modified-p)
		   (y-or-n-p (concat "Save file " fnm "? ")))
	      (save-buffer))
	  (set-buffer mml-compile-output-buffer)
	  (erase-buffer)
	  (set-buffer curbuf)
	  (if (not (zerop (call-process "playmml"
					nil mml-compile-output-buffer nil
					"-bu" fnm)))
	      (progn
		(switch-to-buffer-other-window mml-compile-output-buffer)
		(select-window curwin)))
	  )
      (playmml-buffer)
      )))
(defun playmml-terminate ()
  "Terminate playing MML file."
  (interactive)
  (call-process "playmml" nil nil nil "-k"))
(defun playmml-stop ()
  "Stop playing MML file."
  (interactive)
  (call-process "playmml" nil nil nil "-s"))
(defun playmml-cont ()
  "Continue playing MML file."
  (interactive)
  (call-process "playmml" nil nil nil "-q"))
(defun playmml-view-log ()
  "View MML compile log."
  (interactive)
  (let ((curwin (selected-window)))
    (switch-to-buffer-other-window mml-compile-output-buffer)
    (select-window curwin)))
(defvar mml-mode-map nil
  "Keymap used in MML mode.")
(setq mml-mode-map (make-sparse-keymap))
(define-key mml-mode-map "\C-c\C-c" 'playmml-file)
(define-key mml-mode-map "\C-c\C-b" 'playmml-buffer)
(define-key mml-mode-map "\C-c\C-k" 'playmml-terminate)
(define-key mml-mode-map "\C-c\C-s" 'playmml-stop)
(define-key mml-mode-map "\C-c\C-q" 'playmml-cont)
(define-key mml-mode-map "\C-c\C-v" 'playmml-view-log)
;(define-key mml-mode-map "\C-c`" 'playmml-view-log)
(defvar mml-mode-hook nil
  "MML mode hook.")
